'''
'''

from os import environ as env
from fastapi import FastAPI, APIRouter
from fastapi.responses import RedirectResponse


class SkyAppREST(FastAPI):
    '''
    '''

    def __init__(
        self,
        title: str,
        description: str,
        version: str,
        contact: dict,
        redoc: str = '/doc',
        sdoc: str = None,
        debug: bool = False,
        **kwargs
    ):
        '''
        '''

        assert redoc != '/', 'Parameter \'redoc\' can\'t be root.'
        assert sdoc != '/', 'Parameter \'sdoc\' can\'t be root.'
        assert redoc != sdoc, 'ReDoc & Simple Doc shouldn\'t be equal.'

        sdoc = env.get('SIMPLE_DOC', sdoc)  # env vars have priority
        debug = bool(env.get('DEBUG_API', debug))  # env vars have priority

        super().__init__(
            title=title,
            description=description,
            version=version,
            contact=contact,
            redoc_url=redoc,
            docs_url=sdoc,
            debug=debug,
            **kwargs
        )

        if redoc and redoc != '':

            redir = APIRouter(
                prefix=''
            )

            @redir.get(
                '/',
                response_class=RedirectResponse, status_code=301, include_in_schema=False
            )
            async def redirect():
                '''
                '''
                return redoc

            self.include_router(redir)
